import es, xmpp, repeat

clients = {}

domain = ""
user = ""
pwd = ""
room = ""
roomid = "%s@conference.%s" % (room, domain)
ident = "$"


def load():
    global clients

    m = es.createplayerlist()
    for each in m:
        ev = {'es_username': m[each]['name'], 'userid': each}
        player_activate(ev)
        
    ev = {'es_username': "Console", 'userid': 0}
    player_activate(ev)
    
    clients[0].RegisterHandler('message', remote_say)

    repeat.create("xchat_checker", remote_checker, () )
    repeat.start("xchat_checker", 1, 0)
    
    

    
    
    
def unload():
    global clients
    repeat.delete("xchat_checker")
    for each in clients:
        try:
            clients[each].disconnect()
        except Exception, e:
            print "SERIOUS ERROR! %s" % e
    

def remote_checker():
    global clients
    ret = None
    try:
        ret = clients[0].Process(0)
    except Exception, e:
        print "Error: %s" % e
        


def player_activate(ev):
    global clients, domain, user, pwd, room, roomid, ident
    

    resource = ident + ev['es_username'];

    presenseid = "%s@conference.%s/%s" % (room, domain, resource)
    jid="%s@%s" % (user, domain) 
    jid = xmpp.protocol.JID(jid)
    
    
    cl = xmpp.Client(jid.getDomain(), debug=[])
    
    if cl.connect(use_srv=False) == "":
        print "Not connected"

    if cl.auth(jid.getNode(),pwd, resource) == None:
        print "authentication failed"

    cl.sendInitPresence()
    cl.send(xmpp.Presence(to=presenseid))
    
    clients[int(ev['userid'])] = cl

def player_disconnect(ev):
    global clients
    
    if int(ev['userid']) in clients:
        try:
            clients[int(ev['userid'])].disconnect()
        finally:
            del clients[int(ev['userid'])]
            
def player_changename(ev):
    global clients, room, domain
    if int(ev['userid']) in clients:
        cl = clients[int(ev['userid'])]
        presenseid = "%s@conference.%s/%s" % (room, domain, ident + ev['newname'])
        cl.send(xmpp.Presence(to=presenseid))
    
    

            
def player_say(ev):
    global clients, roomid
    

    name = ev['es_username']
    text = ev['text']
    
    if int(ev['userid']) in clients:
        cl = clients[int(ev['userid'])]
        cl.send(xmpp.protocol.Message(roomid,text,typ="groupchat"))
    
def remote_say(conn,msg):

    global clients
    name = unicode( msg.getFrom() ).split('/')[1]
    
    if name[0] != ident:
        try:
            es.msg("[Jabber] %s: %s" % (name, str(msg.getBody()) ) )
        except Exception, e:
            print "Error in remote chat: %s" % e
            
    
